package Main;

import Pieces.*;

public class Board {
    private Piece board[][] = new Piece[8][8];
    public Board(){
        board[0][0] = new Rook(0,0,false,this);
        board[0][7] = new Rook(0,7,false,this);
        board[0][1] = new Knight(0,1,false,this);
        board[0][6] = new Knight(0,6,false,this);
        board[0][2] = new Bishop(0,2,false,this);
        board[0][5] = new Bishop(0,5,false,this);
        board[0][3] = new King(0,3,false,this);
        board[0][4] = new Queen(0,4,false,this);


        for (int i = 0 ; i < 8 ; i++){
            board[1][i] = new Pawn(1,i,false,this);
            board[6][i] = new Pawn(6,i,true,this);
        }

        board[7][0] = new Rook(7,0,true,this);
        board[7][7] = new Rook(7,7,true,this);
        board[7][1] = new Knight(7,1,true,this);
        board[7][6] = new Knight(7,6,true,this);
        board[7][2] = new Bishop(7,2,true,this);
        board[7][5] = new Bishop(7,5,true,this);
        board[7][3] = new Queen(7,3,true,this);
        board[7][4] = new King(7,4,true,this);

    }
    public boolean getMove(int x , int y , int destX , int destY){
        if(board[x][y]==null) return false;
        if (board[x][y].isValidMove(destX,destY)){
            board[x][y].setX(destX);
            board[x][y].setY(destY);
            board[destX][destY] = board[x][y];
            board[x][y] = null;
            return true;
        }
        else return false;
    }
    public Piece[][] getBoard() {
        return board;
    }
    public boolean isEmpty(int x , int y){
        if (board[x][y] ==null) return true;
        return false;
    }
    public int getColor(int x , int y){
        if(isEmpty(x, y)) return 0;
        if (board[x][y].isWhite()) return 1;
        if (board[x][y].isBlack()) return 2;

        return 0;
    }

    @Override
    public String toString() {
        String str = "";
        for (int i = 0 ; i < 8 ; i++){
            for (int j = 0 ; j < 7 ; j++){
                if(board[i][j]!=null) {
                    str = str + board[i][j] + " ";
                }
                else
                    str = str + "0 ";
            }
            if(board[i][7]!=null) {
                str = str + board[i][7] + "\n";
            }
            else
                str = str + "0\n";
        }
        return str;
    }
}
