package Pieces;

import Main.Board;

import java.util.ArrayList;

public class Pawn extends Piece {


    public Pawn(int x, int y, boolean isWhite, Board board) {
        super(x, y, isWhite, board);
    }

    @Override
    public boolean isCanMove(int dx, int dy) {
        if(isOutside(dx,dy)) return false;
        return false;
    }

    @Override
    public boolean isValidMove(int dx, int dy) {
        return isCanMove(dx, dy);
    }

    @Override
    public ArrayList<int[]> moves() {
        ArrayList<int[]> moves = new ArrayList<>();
        int x = getX();
        int y = getY();
        if(isWhite())
        {
            if(x==0)
                return moves;
            if(getBoard().isEmpty(x-1,y))
            {
                moves.add(new int[]{x-1,y});
                if(x==6)
                {
                    if(getBoard().isEmpty(4,y))
                        moves.add(new int[]{4,y});
                }
            }
            if((y>0)&& ((getBoard().getColor(x-1,y-1)==2 && isWhite() ||getBoard().getColor(x-1,y-1)==1 && isBlack())))
                moves.add(new int[]{x-1,y-1});
            if((y<7)&&((getBoard().getColor(x-1,y+1)==2 && isWhite() ||getBoard().getColor(x-1,y+1)==1 && isBlack())))
                moves.add(new int[]{x-1,y+1});
        }
        else
        {
            if(x==8)
                return moves;
            if(getBoard().isEmpty(x+1,y))
            {
                moves.add(new int[]{x+1,y});
                if(x==1)
                {
                    if(getBoard().isEmpty(3,y))
                        moves.add(new int[]{3,y});
                }
            }
            if((y>0)&& ((getBoard().getColor(x+1,y-1)==2 && isWhite() ||getBoard().getColor(x+1,y-1)==1 && isBlack())))
                moves.add(new int[]{x+1,y-1});
            if((y<7)&&((getBoard().getColor(x+1,y+1)==2 && isWhite() ||getBoard().getColor(x+1,y+1)==1 && isBlack())))
                moves.add(new int[]{x+1,y+1});
        }
        return moves;
    }

    @Override
    public String toString() {
        return "P";
    }
}
